Index: doc/Makefile.am
===================================================================
--- doc/Makefile.am	(revision 633)
+++ doc/Makefile.am	(revision 634)
@@ -15,19 +15,22 @@
 
 DOC_EPS_IMAGES18 = \
+	grid_graph.eps \
+	nodeshape_0.eps \
+	nodeshape_1.eps \
+	nodeshape_2.eps \
+	nodeshape_3.eps \
+	nodeshape_4.eps
+
+DOC_EPS_IMAGES27 = \
 	bipartite_matching.eps \
 	bipartite_partitions.eps \
 	connected_components.eps \
 	edge_biconnected_components.eps \
-	grid_graph.eps \
 	node_biconnected_components.eps \
-	nodeshape_0.eps \
-	nodeshape_1.eps \
-	nodeshape_2.eps \
-	nodeshape_3.eps \
-	nodeshape_4.eps \
 	strongly_connected_components.eps
 
 DOC_EPS_IMAGES = \
-	$(DOC_EPS_IMAGES18)
+	$(DOC_EPS_IMAGES18) \
+	$(DOC_EPS_IMAGES27)
 
 DOC_PNG_IMAGES = \
@@ -45,4 +48,15 @@
 	if test ${gs_found} = yes; then \
 	  $(GS_COMMAND) -sDEVICE=pngalpha -r18 -sOutputFile=$@ $<; \
+	else \
+	  echo; \
+	  echo "Ghostscript not found."; \
+	  echo; \
+	  exit 1; \
+	fi
+
+$(DOC_EPS_IMAGES27:%.eps=doc/gen-images/%.png): doc/gen-images/%.png: doc/images/%.eps
+	-mkdir doc/gen-images
+	if test ${gs_found} = yes; then \
+	  $(GS_COMMAND) -sDEVICE=pngalpha -r27 -sOutputFile=$@ $<; \
 	else \
 	  echo; \
Index: doc/images/bipartite_partitions.eps
===================================================================
--- doc/images/bipartite_partitions.eps	(revision 633)
+++ doc/images/bipartite_partitions.eps	(revision 634)
@@ -2,6 +2,5 @@
 %%Creator: LEMON, graphToEps()
 %%CreationDate: Tue Nov 15 16:51:43 2005
-%%BoundingBox: 0 0 596 842
-%%DocumentPaperSizes: a4
+%%BoundingBox: 0 0 842 596
 %%EndComments
 /lb { setlinewidth setrgbcolor newpath moveto
@@ -47,4 +46,6 @@
 
 gsave
+90 rotate
+0 -842 translate
 71.6378 15 translate
 0.389093 dup scale
Index: doc/images/connected_components.eps
===================================================================
--- doc/images/connected_components.eps	(revision 633)
+++ doc/images/connected_components.eps	(revision 634)
@@ -2,6 +2,5 @@
 %%Creator: LEMON, graphToEps()
 %%CreationDate: Fri Nov  4 13:47:12 2005
-%%BoundingBox: 0 0 596 842
-%%DocumentPaperSizes: a4
+%%BoundingBox: 0 0 842 596
 %%EndComments
 /lb { setlinewidth setrgbcolor newpath moveto
@@ -47,4 +46,6 @@
 
 gsave
+90 rotate
+0 -842 translate
 71.0944 15 translate
 0.434694 dup scale
Index: doc/images/edge_biconnected_components.eps
===================================================================
--- doc/images/edge_biconnected_components.eps	(revision 633)
+++ doc/images/edge_biconnected_components.eps	(revision 634)
@@ -2,6 +2,5 @@
 %%Creator: LEMON, graphToEps()
 %%CreationDate: Fri Nov  4 13:47:12 2005
-%%BoundingBox: 0 0 596 842
-%%DocumentPaperSizes: a4
+%%BoundingBox: 0 0 842 596
 %%EndComments
 /lb { setlinewidth setrgbcolor newpath moveto
@@ -47,4 +46,6 @@
 
 gsave
+90 rotate
+0 -842 translate
 71.0944 15 translate
 0.434694 dup scale
Index: doc/images/node_biconnected_components.eps
===================================================================
--- doc/images/node_biconnected_components.eps	(revision 633)
+++ doc/images/node_biconnected_components.eps	(revision 634)
@@ -2,6 +2,5 @@
 %%Creator: LEMON, graphToEps()
 %%CreationDate: Fri Nov  4 13:47:12 2005
-%%BoundingBox: 0 0 596 842
-%%DocumentPaperSizes: a4
+%%BoundingBox: 0 0 842 596
 %%EndComments
 /lb { setlinewidth setrgbcolor newpath moveto
@@ -47,4 +46,6 @@
 
 gsave
+90 rotate
+0 -842 translate
 71.0944 15 translate
 0.434694 dup scale
Index: doc/images/strongly_connected_components.eps
===================================================================
--- doc/images/strongly_connected_components.eps	(revision 633)
+++ doc/images/strongly_connected_components.eps	(revision 634)
@@ -2,6 +2,5 @@
 %%Creator: LEMON, graphToEps()
 %%CreationDate: Fri Nov  4 13:47:12 2005
-%%BoundingBox: 0 0 596 842
-%%DocumentPaperSizes: a4
+%%BoundingBox: 0 0 842 596
 %%EndComments
 /lb { setlinewidth setrgbcolor newpath moveto
@@ -47,4 +46,6 @@
 
 gsave
+90 rotate
+0 -842 translate
 77.1122 15 translate
 0.585745 dup scale